Package ru.bitel.bgbilling.modules.cerbercrypt.common.service

# Interface CardPacketService

    public interface CardPacketService

Карт-пакеты в админке.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `java.util.List<CardPacket>` | `cardPacketFutureList​(int contractId, int userCardId, java.util.Date now)` | Получение будущих карт-пакетов для указанной карты договора.
  `java.util.List<StatusEvent>` | `cardPacketStatusTable​(int cardPacketId)` | Договор -> модули -> церберкрипт -> Пакеты Задания на смену статусов конкретного картпакета.
  `java.util.List<CardPacket>` | `cardPacketTable​(int objectId, int usercardId, java.util.Date date, boolean cinema, int cid)` | Старый экшен ActionCardPacketTable("objectId"(дефолт -1)"card"(дефолт -1)"date""virtual_cinema"(дефолт false)).
  `void` | `changeStatus​(int cardPacketId, int status, java.util.Date date)` | Договор -> модули -> церберкрипт -> Пакеты Задания на смену статусов.
  `void` | `closeCardPackets​(java.lang.String cards, java.lang.String packets, java.util.Date date, int cid, boolean check)` |
  `void` | `deleteCardPacket​(int cid, int cardPacketId, boolean check)` | Договор -> модули -> церберкрипт -> Пакеты Удаление пакета с карты (картпакета)
  `CardPacket` | `getCardPacket​(int cardPacketId)` | Получение картпакета по id.
  `void` | `openCardPackets​(java.lang.String cards, java.lang.String packets, java.util.Date date, int cid, boolean check)` |
  `void` | `syncCardPackets​(UserCard ucFrom, UserCard ucTo, java.util.Date date, boolean includeUncopyable)` | Копирование подписки с одной карты на другую.
  `void` | `updateCardPacket​(CardPacket cardPacket, boolean check, int date1Hour)` | "UpdateCardPacket" Договор -> модули -> церберкрипт -> Пакеты Договор -> модули -> церберкрипт -> Витруальны кинозалъ

- ## Method Details

  - ### cardPacketTable

    java.util.List<CardPacket> cardPacketTable​(int objectId, int usercardId, java.util.Date date, boolean cinema, int cid) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Старый экшен ActionCardPacketTable("objectId"(дефолт -1)"card"(дефолт -1)"date""virtual_cinema"(дефолт false)).
    Returns:
      список
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### cardPacketStatusTable

    java.util.List<StatusEvent> cardPacketStatusTable​(int cardPacketId) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Договор -> модули -> церберкрипт -> Пакеты Задания на смену статусов конкретного картпакета.
    Parameters:
      `cardPacketId` - ид картпакета
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### deleteCardPacket

    void deleteCardPacket​(int cid, int cardPacketId, boolean check) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Договор -> модули -> церберкрипт -> Пакеты Удаление пакета с карты (картпакета)
    Parameters:
      `cid` -
      `cardPacketId` -
      `check` - проверять или нет дополнительные проверки. если да, и какой-то косяк, то будет экзепшен. иначе удалится молча.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getCardPacket

    CardPacket getCardPacket​(int cardPacketId) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Получение картпакета по id.
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### changeStatus

    void changeStatus​(int cardPacketId, int status, java.util.Date date) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Договор -> модули -> церберкрипт -> Пакеты Задания на смену статусов. "Установить".
    Parameters:
      `cardPacketId` - ид картпакета
      `status` - статус пакета в церберкрипте
      `date` - дата статуса
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### updateCardPacket

    void updateCardPacket​(CardPacket cardPacket, boolean check, int date1Hour) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    "UpdateCardPacket" Договор -> модули -> церберкрипт -> Пакеты Договор -> модули -> церберкрипт -> Витруальны кинозалъ
    Parameters:
      `cardPacket` -
      `check` -
      `date1Hour` - для вирт кинозала тока
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### openCardPackets

    void openCardPackets​(java.lang.String cards, java.lang.String packets, java.util.Date date, int cid, boolean check) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### closeCardPackets

    void closeCardPackets​(java.lang.String cards, java.lang.String packets, java.util.Date date, int cid, boolean check) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### syncCardPackets

    void syncCardPackets​(UserCard ucFrom, UserCard ucTo, java.util.Date date, boolean includeUncopyable) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Копирование подписки с одной карты на другую. Подписка на карте назначения будет очищена и заменена на подписку другой карты! Аналог однократного "ручного мультирума".
    Parameters:
      `ucFrom` - откуда
      `ucTo` - куда
      `date` - дата с которой начнутся пакеты, если null - то даты возьмутся с оригинальной карты
      `includeUncopyable` - включая карты, которые помечены в тарифе как "некопируемые на мультирум" (т.е. true - не проверять тариф на эту возможность)
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### cardPacketFutureList

    java.util.List<CardPacket> cardPacketFutureList​(int contractId, int userCardId, java.util.Date now) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Получение будущих карт-пакетов для указанной карты договора.
    Parameters:
      `contractId` - ID договора
      `userCardId` - ID карты договора
      `now` - текущее время
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`